//Video Handling Functions
//ver 1.6

#ifndef __CRT_H
#define __CRT_H

#if !defined( __DEFS_H)
#include <_defs.h>
#endif

#ifdef CRT_FULL
#define SAVECRT
#define RESTORECRT
#define SAVECRTWIN
#define RESTORECRTWIN
#endif

extern int _Cdecl vmode_x; //number of collumns in text mode (default=80)
extern int _Cdecl vmode_y; //number of rows in text mode (default=25)
extern int _Cdecl crt_direct; //set BIOS use if != 0. (default=0)
extern int _Cdecl crt_page; //selects the text page that must be used by
									 //functions

extern char far * _Cdecl video_addr; //base VIDEO RAM address
extern const char _Cdecl crtframe_mat[]; //array used by crtframe
extern const char _Cdecl mkline_mat[]; //array used by mkline

	/* * * FUNCTIONS * * */

#ifdef __cplusplus
extern "C" {
#endif
void		_Cdecl	videomode (int newmode);
void		_Cdecl	crt_gotoxy	(int  x, int y );
int		_Cdecl	crt_getxy	(int *x, int *y);
int		_Cdecl	getcrtchar	(int  x,	int y );
int		_Cdecl	getcrtcolor (int  x, int y );
void		_Cdecl	biosprintc  (int chr, int x, int y, int color, int func);
void		_Cdecl	printcn	(int c, int x, int y);
void		_Cdecl	printc	(int c, int x, int y, int color);
void		_Cdecl	changecolor (int x, int y, int color);
void		_Cdecl	printsn	(char *s, int x, int y);
void		_Cdecl	prints	(char *s, int x, int y, int color);
void		_Cdecl	printxy	(char *s, int x, int y, int dx, int dy, int color);
void		_Cdecl	printx	(char *s, int x, int y, int color);
int 		_Cdecl	printsnf	(int x, int y,					char *fmt,... );
int 		_Cdecl	printsf	(int x, int y, int color,	char *fmt,... );
int _Cdecl	printxyf (int x, int y, int dx, int dy, int color, char *fmt,... );
int 		_Cdecl	printxf	(int x, int y, int color, 	char *fmt,... );
void		_Cdecl	fillscr	(int c, int color);
void		_Cdecl	fillbar	(int c, int xi, int yi, int xf, int yf, int color);
void		_Cdecl	crtframe	(int xi, int yi, int xf, int yf, int color, unsigned int type);
void		_Cdecl	mkline_aux (int cnt, int var, unsigned int mode, int pos, int color);
void		_Cdecl	mkline	(int cnt, int bgn, int end, int color, unsigned int mode);
char far *_Cdecl	savevideo		(char far *s);
char far *_Cdecl	restorevideo	(char far *s);
char far *_Cdecl	savevideowin	(char far *str, int xi, int yi, int xf, int yf);
char far *_Cdecl	restorevideowin(char far *str, int xi, int yi, int xf, int yf);

#ifdef SAVECRT
char far *_Cdecl	savecrt			(char far *s, int mode);
#define savevideo(s) savecrt(s,0)
#endif

#ifdef RESTORECRT
char far *_Cdecl	restorecrt		(char far *s, int mode);
#define restorevideo(s) restorecrt(s,0)
#endif

#ifdef SAVECRTWIN
char far *_Cdecl  savecrtwin		(char far *s, int xi, int yi, int xf, int yf, int mode);
#define savevideowin(s,xi,yi,xf,yf) savecrtwin(s,xi,yi,xf,yf,0)
#endif

#ifdef RESTORECRTWIN
char far *_Cdecl  restorecrtwin	(char far *s, int xi, int yi, int xf, int yf, int mode);
#define restorevideowin(s,xi,yi,xf,yf) restorecrtwin(s,xi,yi,xf,yf,0)
#endif

void	_Cdecl	setcursorsh (unsigned int shape);
int	_Cdecl	getcursorsh (void);
#ifdef __cplusplus
}
#endif

//defined macros

	//moldura: (draws a text frame with single line)
#define moldura(xi,yi,xf,yf,color)\
	crtframe(xi,yi,xf,yf,color,0)
	//moldurad: (draws a text frame with double line)
#define moldurad(xi,yi,xf,yf,color)\
	crtframe(xi,yi,xf,yf,color,1)

	//mkline macros
#define linha_hor(y,xi,xf,color)\
	mkline(y,xi,xf,color,0) //draws a single horizontal line
#define linha_ver(x,yi,yf,color)\
	mkline(x,yi,yf,color,1) //draws a single vertical line
#define linhad_hor(y,xi,xf,color)\
	mkline(y,xi,xf,color,2) //draws a double horizontal line
#define linhad_ver(x,yi,yf,color)\
	mkline(x,yi,yf,color,3) //draws a double horizontal line

#endif

// By Mrcio Afonso Arimura Fialho
// Email: jlfialho@inconet.com.br
// http://www.iconet.com.br/jlfialho
// Shareware Library Functions - Free Distribution and Use.
